exports.install = function() {
	CORS();
	ROUTE('POST /upload/ @upload <5MB', upload);
	ROUTE('FILE /download/*.*', download);
};

async function upload($) {

	var output = [];

	for (var file of $.files) {
		var response = await file.fs('files', UID());
		response.url = 
'/download/{0}.{1}'.format(response.id.sign(CONF.salt), response.ext);
		output.push(response.url);
	}

	$.json(output);
}

function download($) {

	var index = $.split[1].lastIndexOf('.');
	if (index !== -1) {
		var hash = $.split[1].substring(0, index);
		var id = hash.substring(0, hash.indexOf('-', 10));
		if (hash === id.sign(CONF.salt)) {
			$.filefs('files', id);
			return;
		}
	}

	$.throw404();
};
